/*******************************************************************************
*                                 ZM4xx
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-present Guangzhou ZHIYUAN Electronics Co., Ltd.
* ALL rights reserved.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
* 
* The software is free to use in a commercial product and should not be
* redistributed in any way. See the LICENSE file for more details.
* 
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ZM4xx Demo(жϽ)
 *
 * - 裺
 *   1.ʹUSBDEMOԣ򿪴֣Ϊ115200λ8bitֹͣλ1bitУλ
 *   2.ʹôն˷ݰ߰°SW1ݰ
 *   3.ն˵ĴֿԲ鿴յݣ
 *   4.SW2Ըı䷢书ʡ
 *
 * \internal
 * \par Modification history
 * - 1.00 17-11-22  sup, first implementation.
 * \endinternal
 */

#include "string.h"
#include "stddef.h"
#include "stdint.h"
#include "stdio.h"

#include "radio.h"
#include "board_gpio.h"
#include "board_uart.h"
#include "board_int.h"
#include "radio_int.h"

#include "gpio.h"
#include "ddl.h"



#define    FREQ          (470000000)

/* S2ݰ */
static char *__gp_test_str = "WIRELESS SX126X TEST !\r\n";


static uint8_t        __g_data_buf[512] = {0};                         
static uint16_t       __g_recv_byte     = 0;                                
static uint16_t       __g_send_byte     = 0;
static radio_handle_t __gp_handle;



/**
 * \brief  SW1ӦжϷһ
 */
static void __sw1_int_handle (void)
{
    uint16_t  i = 0;
    for (i = 0; i < strlen(__gp_test_str); i++) {
        __g_data_buf[i] = __gp_test_str[i];
    }
    __g_send_byte  = strlen(__gp_test_str);
}


/**
 * \brief  SW2ӦжϷ,ı䷢书(-9~22dBm)
 */
static void __sw2_int_handle (void) 
{   
    static uint8_t pa_level = 0;
    static float   pa_val;

    if (pa_level > 7) {
        pa_level = 0;
    }

    radio_tx_power_set(__gp_handle, pa_level, &pa_val);
    printf("tx power set %.2f dBm ok\r\n", pa_val);

    pa_level++;
}

/**
 * \brief  ģжϷ
 */
static void __radio_recv_int_handle (void)
{
    int      ret = 0;
    uint8_t  len = 0;

    ret = radio_data_recv(__gp_handle, __g_data_buf, &len);  
    if (ret == RADIO_RET_OK) {
        __g_recv_byte = len;
    }
}

void demo_zm4xx_int_entry (radio_handle_t handle)
{
    uint32_t key;
    uint16_t pkt_size = 0;
    uint8_t  recv_buf[512];
    uint16_t recv_data_size = 0;
    uint16_t i = 0;

    __gp_handle = handle;
    
    /* 
     * ƵʵȲҪȽģʽпòɹ
     * ģ޷(߳ʹýӿ) 
     */
    radio_mode_set(handle, STANDBY_MODE);
    
    /* Ϊģʽ(߳ʹýӿ)   */
    radio_mode_set(handle, RX_MODE);

    
    /* 
     * ģжϳʼ
     * ģʹжϽģʽʵָýӿڣ
     * ʵݰDIO1ŽжϹúDIO1жϷ׼
     */
    radio_int_init(handle,__radio_recv_int_handle);

    /* ʼж */
    mcu_sw1_int_init(__sw1_int_handle);
    mcu_sw2_int_init(__sw2_int_handle);

    while (1) {
        
        /* 
         * ģģʽʱܲжϵݱǣ
         * ýյݿµĻĹ
         */
        key = cpu_lock();
        if (__g_recv_byte > 0) {
            memcpy(recv_buf, __g_data_buf, __g_recv_byte);
            recv_data_size = __g_recv_byte;
            __g_recv_byte = 0;
        }
        cpu_unlock(key);

        /*    */
        if (recv_data_size > 0) {

            mcu_gpio_pin_toggle(GpioPortA, GpioPin3);

            /*  ݴӴڷͳȥ  */
            for (i = 0; i < recv_data_size; i++) {
                mcu_uart_byte_send(__g_data_buf[i]);
            }

            recv_data_size = 0;
            /* 
             * ΪνģʽҪٴνģʽ½н
             * ΪģʽҪٴνģʽڽ֮ᱣֽģʽ
             * (߳ʹýӿ)  
             */
            radio_mode_set(handle, RX_MODE);
            
        }

        /*    */
        if (__g_send_byte > 0) {   

            mcu_gpio_pin_toggle(GpioPortC, GpioPin4);

            /* ߷(߳ʹýӿ) */
            radio_data_send(handle, __g_data_buf, __g_send_byte);      

            /* 
             * ͺŵģֻҪݾͱлؽģʽ޷ 
             * (߳ʹýӿ) 
             */
            radio_mode_set(handle, RX_MODE);

            __g_send_byte = 0;

        }

        /* ӴڻȡҪ͵ݰ */
        if (mcu_uart_recv_pkt(__g_data_buf, &pkt_size) == 0) {
            __g_send_byte = pkt_size;
        }

    }
}







