/*******************************************************************************
*                                 ZM4xx
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-present Guangzhou ZHIYUAN Electronics Co., Ltd.
* ALL rights reserved.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
* 
* The software is free to use in a commercial product and should not be
* redistributed in any way. See the LICENSE file for more details.
* 
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ZM4xx CAD ģʽ 
 * \note   
 *
 * - 裺
 *   1.ʹUSBDEMOԣ򿪴֣Ϊ115200λ8bitֹͣλ1bitУλ
 *
 * - ʵ
 *    2. յͨڴӡ
 *
 *  CAD ˵
 *  CADģʽŵģʽ,ּԾܸߵĹЧʼŵϵLoRaǰ, ÿڿһ
 *           CADڼݣʱߣ˿Խ͹ġ
 *
 *                  CADģʽ     IDLEģʽ        CADģʽ
 *                   _____                      ______
 *            _______| t1 |________t2___________| t1 |_______
 *          _CAD->|___|<--- ʱ------>|__________
 *
 *  һLoRaݰԼ򵥵Ŀǡǰ롿+ݡնͨǷǰݣΪCADܹ⵽ǰ
 *  Ӧʹǰķʱڣt1 + t2ǰĿʱͨLoRaٷ㡣
 *            +-----------+----------+
 *            | ǰ    |       |
 *            +-----------+----------+
 *
 *  ڵνģʽɺлģʽ
 *  ģʽɺǻᱣڽģʽҪûлشģʽ޷ٽCADģʽ
 *
 * \note 
 *
 * \internal
 * \par Modification history
 * - 1.00 18-08-06  vir, first implementation.
 * \endinternal
 */
 
#include "string.h"
#include "stddef.h"
#include "stdint.h"
#include "stdio.h"

#include "radio.h"
#include "board_gpio.h"
#include "board_uart.h"
#include "board_int.h"
#include "radio_int.h"

#include "gpio.h"
#include "ddl.h"


#define FREQ          (470000000)

static uint8_t        __g_data_buf[256] = {0};                           
static uint16_t       __g_recv_byte     = 0;                                
static radio_handle_t __gp_handle;


/**
 * \brief  ģжϷ
 */
static void __radio_recv_int_handle (void)
{
    int      ret = 0;
    uint8_t  len = 0;

    ret = radio_data_recv(__gp_handle, __g_data_buf, &len);  /*    */
    if (ret == RADIO_RET_OK) {
        __g_recv_byte = len;
    }

    /* ݺʡ */
    radio_mode_set(__gp_handle, SLEEP_MODE);  

}


void demo_zm4xx_rxdata_cad_only(radio_handle_t handle)
{
    uint16_t i     = 0;
    uint8_t cad_st = 0;
    radio_state_t rf_st;

    __gp_handle = handle;

    /* Ƶ */
    // radio_freq_set(handle, FREQ);

    /* 
     * ģжϳʼ
     * ģʹжϽģʽʵָýӿڣ
     * ʵݰDIO1ŽжϹúDIO1жϷ׼
     */
    radio_int_init(handle, __radio_recv_int_handle);

    while (1) {

        radio_state_get(handle,&rf_st); 

        /* ǰǽģʽ򲻿CADCADӰ */
        if( rf_st != RX_RUNING_ST) {    
            /* CAD ,ͽӿڣֱCAD˳ */

            radio_ioctl(handle, SET_CAD_ONLY, NULL);

            radio_ioctl(handle, CAD_START, &cad_st);

            if( cad_st == CAD_DETECT) {    /* ⵽Чǰ */
                 radio_mode_set(handle, RX_MODE); /* ģʽ׼ */
                 printf("cad detect\r\n");        /* ע⣡⵽CAD DETECTźŲζܳɹյݣһʧܸ(ǰɽʧܸ)
                                                   * ݽʧܻ
                                                   * 1.ģʽ£ֽжϣradio_buf_recv޷ݡʱģ齫һֱڽģʽ
                                                   *   ʱҪûԼģղݵˣʱʱʱΪǰ볤ȵʱ䣬ʱͽģʽʡ硣
                                                   * 
                                                   * 2.ڵνģʽ£RX TIMEOUTжźţźģڲĽճʱźʱDIO1
                                                   *   źţûҪⲿжʱradio_dio1_irq_func(__gp_handle)ʹģ»ص
                                                   *   ģʽʡ硣
                                                   */

            } else {                              /* ⲻЧǰ */
                radio_mode_set(handle, SLEEP_MODE);  
            }
        }

        /*    */
        if (__g_recv_byte > 0) {

            mcu_gpio_pin_toggle(GpioPortA, GpioPin3);

            /*  ݴӴڷͳȥ  */
            for (i = 0; i < __g_recv_byte; i++) {
                mcu_uart_byte_send(__g_data_buf[i]);
            }
            __g_recv_byte = 0;
        }

        /* ʱCADĿ */
        delay1ms(3);

    }
}





