/*******************************************************************************
*                                 ZM4xx
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-present Guangzhou ZHIYUAN Electronics Co., Ltd.
* ALL rights reserved.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
* 
* The software is free to use in a commercial product and should not be
* redistributed in any way. See the LICENSE file for more details.
* 
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief Main
 *
 * \internal
 * \par Modification history
 * - 1.00 17-11-22  sup, first implementation.
 * \endinternal
 */

#include "ddl.h"
#include "radio.h"
#include "string.h"
#include "sysctrl.h"
#include "board_gpio.h"
#include "board_uart.h"
#include "board_spi.h"
#include "demo_all_entries.h"



/*
 * ģģʽѡ
 * 1ѡLoRaģʽĬϣ
 * 0ѡFSKģʽ
 * ע⣺FSKģʽ֧CADز̣
 */ 
#define    __LORA_MODULATION_ENABLE    1


extern void sysclk_init (void);


int32_t main(void)
{
    /* radio */
    radio_handle_t handle;

    /* ϵͳʱӳʼ */
    sysclk_init();
    
    /* GPIOųʼ */
    mcu_gpio_init();
    
    /* SPIʼ */  
    mcu_spi_init();
    
    /* ͹Ĵڳʼ */
    mcu_uart_init(115200, 256, NULL);
    
    /* ʵʼģ */
#if __LORA_MODULATION_ENABLE
    extern radio_handle_t radio_lora_zm4xx_inst_init (void);
    handle = radio_lora_zm4xx_inst_init();
#else 
    extern radio_handle_t radio_fsk_zm4xx_inst_init (void);
    handle = radio_fsk_zm4xx_inst_init();
#endif

    /* жģʼؾǷΪ */
    if (handle != NULL) {   

        /* demo ڵ */
        demo_zm4xx_polling_entry(handle);
        
    }

    while (1);

}





