/*******************************************************************************
*                                 ZM4xx
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-present Guangzhou ZHIYUAN Electronics Co., Ltd.
* ALL rights reserved.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
* 
* The software is free to use in a commercial product and should not be
* redistributed in any way. See the LICENSE file for more details.
* 
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief жϴ
 * 
 * \internal
 * \par Modification history
 * - 1.00 17-11-22  sup, first implementation.
 * \endinternal
 */
 
#include "stdio.h"
 
#include "gpio.h"
#include "base_types.h"
#include "ddl.h"

#include "board_int.h"
#include "board_gpio.h"



static  pfn_sw_int_cb  __g_sw1_int_handle;
static  pfn_sw_int_cb  __g_sw2_int_handle;
 


/* SW1(PIOA_0)ųʼ */
static void __sw1_init (void)
{
    stc_gpio_cfg_t stcGpioCfg;

    Sysctrl_SetPeripheralGate(SysctrlPeripheralGpio, TRUE);

    stcGpioCfg.enDir = GpioDirIn;
    stcGpioCfg.enDrv = GpioDrvL;        /* ˿-> */
    stcGpioCfg.enPu  = GpioPuEnable;    /*      */
    stcGpioCfg.enPd  = GpioPdDisable;   /*   */

    stcGpioCfg.enCtrlMode = GpioAHB;    /* ˿/ֵĴ߿ģʽ->AHB */
    Gpio_Init(GpioPortA, GpioPin0, &stcGpioCfg); 

    Gpio_EnableIrq(GpioPortA, GpioPin0, GpioIrqFalling);  /* ½жϲʹ */

    EnableNvic(PORTA_IRQn, IrqLevel2, TRUE); /* ʹܶ˿PORTAϵͳж */
}


/* SW2(PIOB_10)ųʼ */
static void __sw2_init (void)
{
    stc_gpio_cfg_t stcGpioCfg;

    Sysctrl_SetPeripheralGate(SysctrlPeripheralGpio, TRUE);

    stcGpioCfg.enDir = GpioDirIn;
    stcGpioCfg.enDrv = GpioDrvL;        /* ˿-> */
    stcGpioCfg.enPu  = GpioPuEnable;    /*      */
    stcGpioCfg.enPd  = GpioPdDisable;   /*   */

    stcGpioCfg.enCtrlMode = GpioAHB;    /* ˿/ֵĴ߿ģʽ->AHB */
    Gpio_Init(GpioPortB, GpioPin10, &stcGpioCfg); 

    Gpio_EnableIrq(GpioPortB, GpioPin10, GpioIrqFalling);  /* ½жϲʹ */

    EnableNvic(PORTB_IRQn, IrqLevel2, TRUE); /* ʹܶ˿PORTBϵͳж */
}
 
/* SW1жϷ */
void PortA_IRQHandler(void)
{
    if(TRUE == Gpio_GetIrqStatus(GpioPortA, GpioPin0)) {
        delay1ms(5);
        while (Gpio_GetInputIO(GpioPortA, GpioPin0) == 0){;}

        if( __g_sw1_int_handle) {
            __g_sw1_int_handle();
        }
    }

    Gpio_ClearIrq(GpioPortA, GpioPin0);
}

/* SW2жϷ */
void PortB_IRQHandler(void)
{
    if(TRUE == Gpio_GetIrqStatus(GpioPortB, GpioPin10)) {
        delay1ms(5);
        while (Gpio_GetInputIO(GpioPortB, GpioPin10) == 0){;}

        if( __g_sw2_int_handle) {
            __g_sw2_int_handle();
        }
    }
    Gpio_ClearIrq(GpioPortB, GpioPin10);
}


/* SW1жϳʼ */
void mcu_sw1_int_init(pfn_sw_int_cb sw1_int_cb)
{
     __sw1_init();
     __g_sw1_int_handle = sw1_int_cb;
}

/* SW2жϳʼ */
void mcu_sw2_int_init(pfn_sw_int_cb sw2_int_cb)
{
     __sw2_init();
     __g_sw2_int_handle = sw2_int_cb;
}

 





