
/*******************************************************************************
*                                 ZM4xx
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-present Guangzhou ZHIYUAN Electronics Co., Ltd.
* ALL rights reserved.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
* 
* The software is free to use in a commercial product and should not be
* redistributed in any way. See the LICENSE file for more details.
* 
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief LoRaģжϴ
 *
 * \internal
 * \par Modification history
 * - 1.00 17-11-22  sup, first implementation.       
 * \endinternal
 */
 
#include "stdio.h"
 
#include "gpio.h"
#include "base_types.h"
#include "ddl.h"

#include "radio_int.h"
#include "board_gpio.h"


static  pfn_radio_int_cb  __g_radio_dio1_int_handle;


/* CPUжϡýӿڱṩ */
uint32_t cpu_lock (void)
{
    uint32_t key = 0;
    
    key = __get_PRIMASK();
    __disable_irq();
    
    return  key;
}

/* CPUжϡýӿڱṩ */
void cpu_unlock (uint32_t cpu_key)
{
    __set_PRIMASK(cpu_key);
}


/*
 * DIO1жϹ
 * ĬΪжģʽ
 */
static void __radio_dio1_int_init (void)
{
    stc_gpio_cfg_t stcGpioCfg;

    Sysctrl_SetPeripheralGate(SysctrlPeripheralGpio, TRUE);

    stcGpioCfg.enDir = GpioDirIn;

    stcGpioCfg.enDrv = GpioDrvL;        /* ˿-> */
    stcGpioCfg.enPu  = GpioPuDisable;   /*  */
    stcGpioCfg.enPd  = GpioPdEnable;    /*    */

    stcGpioCfg.enCtrlMode = GpioAHB;    /* ˿/ֵĴ߿ģʽ->AHB */
    Gpio_Init(GpioPortC, GpioPin12, &stcGpioCfg); 

    Gpio_EnableIrq(GpioPortC, GpioPin12, GpioIrqRising);  /* жϲʹ */

    EnableNvic(PORTC_E_IRQn, IrqLevel0, TRUE); /* ʹܶ˿PORTCϵͳж */
}

/* 
 * DIO1жϷ 
 * DIO1ŲʱжϲӦò㴫߽պݽ
 */
void PortC_IRQHandler (void)
{
    if(TRUE == Gpio_GetIrqStatus(GpioPortC, GpioPin12)) {
        if(__g_radio_dio1_int_handle) {
            /* Ӧò߽պݽ */
            __g_radio_dio1_int_handle();  
        }
        Gpio_ClearIrq(GpioPortC, GpioPin12);
    }
} 


/* 
 * ģжϳʼ
 * ģʹжϽģʽʵָýӿڣ
 * ʵݰDIO1ŽжϹúDIO1жϷ׼
 */
void radio_int_init (radio_handle_t handle, pfn_radio_int_cb radio_int_cb)
{
    __radio_dio1_int_init();
    __g_radio_dio1_int_handle = radio_int_cb;
}











